summaryrefslogtreecommitdiff
path: root/misc/scripts
diff options
context:
space:
mode:
authorRaul Santos <raulsntos@gmail.com>2022-08-27 03:14:27 +0200
committerRaul Santos <raulsntos@gmail.com>2022-08-27 10:11:35 +0200
commitea6b8ecb6fb535004e7a3e8ce6ac7673665144b8 (patch)
tree4ad859ded0a1a4d943141fb6464fcecfe47f8b8c /misc/scripts
parentd35c58507c7b4e1da2c310f3d290c7c13ea8fcf0 (diff)
Add `dotnet format` to CI to check C# style
Diffstat (limited to 'misc/scripts')
-rwxr-xr-xmisc/scripts/dotnet_format.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/misc/scripts/dotnet_format.sh b/misc/scripts/dotnet_format.sh
new file mode 100755
index 0000000000..645737f419
--- /dev/null
+++ b/misc/scripts/dotnet_format.sh
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+
+# This script runs dotnet format on all relevant files in the repo.
+# This is the primary script responsible for fixing style violations in C# files.
+
+set -uo pipefail
+
+# Loops through all C# projects tracked by Git.
+git ls-files -- '*.csproj' \
+ ':!:.git/*' ':!:thirdparty/*' ':!:platform/android/java/lib/src/com/google/*' ':!:*-so_wrap.*' |
+while read -r f; do
+ # Run dotnet format.
+ dotnet format "$f"
+done
+
+diff=$(git diff --color)
+
+# If no diff has been generated all is OK, clean up, and exit.
+if [ -z "$diff" ] ; then
+ printf "Files in this commit comply with the dotnet format style rules.\n"
+ exit 0
+fi
+
+# A diff has been created, notify the user, clean up, and exit.
+printf "\n*** The following changes have been made to comply with the formatting rules:\n\n"
+echo "$diff"
+printf "\n*** Please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
+exit 1